if (exist('data') ~= 1)
	%dataM = load('Micro_Filter_2_7_12.dat')'; %microsoft action
	%dataI = load('iconic.dat')';              %3D Dig gesture
	data1 = load('randomGesture.txt');        %In house random gestures
	data2 = [load('s1.txt');load('s2.txt'); load('s3.txt'); load('s4.txt');]; %In house random gestures
  data = [data1(:,2:61)' data2(:,2:61)'];
	mu_dist = load('mu_dis_2_7_12.dat');
end

num_trg = size(data,2);
num_feature = size(data,1);
proj_data = zeros(size(data));

%Torso Compensation
for index = 1:size(data,2)
	%%Find the Orientation of the Torso
	body_axis = TransformSkeletonToBodyOrientation(data(:,index)');
	%Projects all the raw position data to the new body axis
	tmp_data = body_axis * reshape(data(:,index)',3,20);

	proj_data(:,index) = reshape(tmp_data,60,1); 
end	

%Extract only the arms position and its inverse
proj_arm_pos = TransformSkeletonToArmPos(proj_data');

%Normalized into unit relative vector
[norm_proj_arm_vec mu sigma] = TransformArmPosToArmVec(proj_arm_pos);

%Denormalizing the data
re_proj_arm_vec  = bsxfun(@plus,bsxfun(@times,norm_proj_arm_vec',sigma'),mu');

norm_proj_vec_data = norm_proj_arm_vec';
mu = mu';
sigma = sigma';

%Seq Debug 
figure(1),
for index = 1:1:(num_trg*2)
  index_inv = index+num_trg;
  body_axis = TransformSkeletonToBodyOrientation(data(:,index)'); 
  subplot(3,2,1), show_data(data(:,index)',body_axis);        
  title(['Ground truth ' num2str(index)]);
  subplot(3,2,2), show_data(proj_data(:,index)',[1 0 0;0 1 0; 0 0 1]); 
  title('Torse normalized');
  subplot(3,2,3), ShowArmState(proj_arm_pos(index,:)');       
  title('Upperlimb data'); grid on;
  subplot(3,2,4), ShowArmState(proj_arm_pos(index_inv,:)');   
  title('with mirrored'); grid on;
  subplot(3,2,5), ShowArmState(ConvertVectoArm(re_proj_arm_vec(:,index),mu_dist)); 
  title('with mean length'); grid on;
  subplot(3,2,6), ShowArmState(ConvertVectoArm(re_proj_arm_vec(:,index_inv),mu_dist)); 
  title('with mean length and mirrored'); grid on;
  drawnow;
  pause(0.1);
end

%%Save the data
%num_msr = size(data1,2);
%num_ionic = size(data2,2);
%num_randg = size(data,2);
%save('Allpreprocess_ext','norm_proj_vec_data','mu','sigma','mu_dist','num_randg','num_ionic','num_msr');
%save('Allpreprocess_ext','norm_proj_vec_data','mu','sigma','mu_dist','num_randg');

