function [ norm_vec_data vec_mu, vec_sigma] = TransformArmPosToArmVec( arm_data )
%SKELETONTOARMVEC Summary of this function goes here
%   Detailed explanation goes here

[size_trg total_features] = size(arm_data);

%Converting the global position vector to relative position vector (r.t. the previous linkage)
offset = [zeros(size_trg,3) arm_data(:,1:6) zeros(size_trg,3) arm_data(:,10:15)];
vec_data = arm_data - offset;


%Normalize each linkage to unit vectors such that only angle is taken into consideration
tmp_vec = [];
for j = 1:3
    offset = (j-1)*3;
    pos_1 = 1+offset;
    pos_2 = 3+offset;
    pos_3 = 10+offset;
    pos_4 = 12+offset;
    
    sum_dis = 0;
    for i = 1:size_trg
        %Ncounter(i,1000);
        %sum_dis = sum_dis+norm(vec_data(i,pos_1:pos_2))+norm(vec_data(i,pos_3:pos_4));
        vec_data(i,pos_1:pos_2) = vec_data(i,pos_1:pos_2)./norm(vec_data(i,pos_1:pos_2));
        vec_data(i,pos_3:pos_4) = vec_data(i,pos_3:pos_4)./norm(vec_data(i,pos_3:pos_4));
    end
    %mu_dis(j) = sum_dis/(2*size_trg);
end

%Normalize the data so that all the feature has zero means and unit variances
vec_mu = mean(vec_data);
vec_sigma = std(vec_data);
norm_vec_data = bsxfun(@rdivide, bsxfun(@minus, vec_data, vec_mu),vec_sigma);

end

