function [ bodyAxis ] = TransformSkeletonToBodyOrientation( data )
%SKELETONTOARMVEC Summary of this function goes here
%   Detailed explanation goes here
[num_data num_features] = size(data);
state_arm = zeros(num_data,18);

	for i = 1:1:size(data,1)
			skel = reshape(data(i,:),[3 20])';
			left_shoulder = skel(5,:);
			right_shoulder = skel(9,:);
			spine = skel(2,:);
			neck = skel(3,:);
			
            ref_z_axis = cross((right_shoulder - spine),(left_shoulder - spine)) ... 
                /norm(cross((right_shoulder - spine),(left_shoulder - spine)));
			
			cross((right_shoulder - spine),(left_shoulder - spine));
			y_axis = (neck - spine)/norm((neck - spine));
			
			x_axis = cross(y_axis,ref_z_axis)/norm(cross(y_axis,ref_z_axis));
			
			z_axis = cross(x_axis,y_axis)/norm(cross(x_axis,y_axis));
			
			bodyAxis = [x_axis;y_axis;z_axis]; 
			
			%{
			x = 3; y = 1; z = 2;
			figure(11)
			cla
				hold on
			for j = 1:3 		
				plot3([0 bodyAxis(j,x)],[0 bodyAxis(j,y)],[0 bodyAxis(j,z)]);
			end
			hold off
			%}
	end
end

